#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

void init(){
	
	PORTA = 0;
	PORTC = 0;
	
	DDRC |= _BV(PC0) | _BV(PC1) | _BV(PC2) ;
	
	ADCSRA = 0;
	ADCSRA |= _BV(ADPS2) | _BV(ADPS1) | _BV(ADPS0); //set clock prescaler at 128
	ADCSRA |= _BV(ADEN);	//enable ADC

	
	ADMUX = 0;
	ADMUX |= 0b11000000;	// seteam input pe ADC0
}

int get_signal(){
	ADCSRA |= _BV(ADSC);					// start first conversion
	loop_until_bit_is_set(ADCSRA,ADIF);		// wait until conversion is done: until ADIF from ADCSRA is set to 1
	ADCSRA |= _BV(ADIF);
	return (ADC);							// returns the ADC
}



int main(){
	
	int val = 0;
	
	init();
	
	while(1){
		// daca se bate din palme(1024 maxim)
		if (get_signal() > 1022)
		{
			if ((PORTC & (_BV(PC0) | _BV(PC1) | _BV(PC2))) != 7)	//daca nu sunt aprinse toate LED-urile
			{
				switch (val)
				{
				case 0: 
					PORTC |= _BV(PC0) ;	// aprind 1 LED
					break;
				case 1: 
					PORTC |= _BV(PC0) | _BV(PC1);	// aprind 2 LED-uri
					break;
				case 2: 
					PORTC |= _BV(PC0) | _BV(PC1) | _BV(PC2) ;		//aprind trei LED-uri
					break;
				}
				val = (val + 1) % 3;
			}
			// daca sunt aprinse toate LED-urile
			else
			{
				PORTC = 0;	// le stingem pe toate
			}
			_delay_ms(500);
		}
	}
	
	return 0;
}